---
title: HTMLOrForeignElement.dataset
slug: Web/API/HTMLOrForeignElement/dataset
tags:
  - API
  - HTML DOM
  - HTMLElement
  - HTMLOrForeignElement
  - Property
  - Read-only
  - Reference
  - SVG
  - SVG Custom Attributes
  - SVG2
  - SVGElement
  - dataset
---
<div>{{APIRef("HTML DOM")}}</div>

<p><span class="seoSummary">The <strong><code>dataset</code></strong> read-only property of the {{DOMxRef("HTMLOrForeignElement")}} interface provides read/write access to <a href="/en-US/docs/Web/HTML/Global_attributes/data-*">custom data attributes</a> (<code>data-<var>*</var></code>) on elements.</span> It exposes a map of strings ({{domxref("DOMStringMap")}}) with an entry for each <code>data-*</code> attribute.</p>

<div class="notecard note">
<p>The <code>dataset</code> property itself can be read, but not directly written. Instead, all writes must be to the individual properties within the <code>dataset</code>, which in turn represent the data attributes.</p>
</div>

<p>An HTML <code>data-*</code><var> attribute</var> and its corresponding DOM<strong> </strong><code>dataset.<var>property</var></code> modify their shared name according to where they are read or written:</p>

<dl>
 <dt>In HTML</dt>
 <dd>The attribute name begins with <code>data-</code>. It can contain only letters, numbers, dashes (<code>-</code>), periods (<code>.</code>), colons (<code>:</code>), and underscores (<code>_</code>). Any ASCII capital letters (<code>A</code> to <code>Z</code>) are ignored and converted to lowercase.</dd>
 <dt>In JavaScript</dt>
 <dd>The property name of a custom data attribute is the same as the HTML attribute without the <code>data-</code> prefix, and removes single dashes (<code>-</code>) for when to capitalize the property’s “camelCased” name.</dd>
</dl>

<p>In addition to the information below, you'll find a how-to guide for using HTML data attributes in our article <a href="/en-US/docs/Learn/HTML/Howto/Use_data_attributes"><em>Using data attributes</em>.</a></p>

<h3 id="Name_conversion">Name conversion</h3>

<dl>
 <dt><code>dash-style</code> to <code>camelCase</code> conversion</dt>
 <dd>
 <p>A custom data attribute name is transformed to a key for the {{ domxref("DOMStringMap") }} entry by the following:</p>

 <ol>
  <li>Remove the prefix <code>data-</code> (including the dash);</li>
  <li>For any dash (<code>U+002D</code>) followed by an ASCII lowercase letter <code>a</code> to <code>z</code>, remove the dash and uppercase the letter;</li>
  <li>Other characters (including other dashes) are left unchanged.</li>
 </ol>
 </dd>
 <dt><code>camelCase</code> to <code>dash-style</code> conversion</dt>
 <dd>
 <p>The opposite transformation, which maps a key to an attribute name, uses the following:</p>

 <ol>
  <li><strong>Restriction:</strong> Before transformation, a dash <em>must not</em> be immediately followed by an ASCII lowercase letter <code>a</code> to <code>z</code>;</li>
  <li>Add the <code>data-</code> prefix;</li>
  <li>Add a dash before any ASCII uppercase letter <code>A</code> to <code>Z</code>, then lowercase the letter;</li>
  <li>Other characters are left unchanged.</li>
 </ol>
 </dd>
</dl>

<p>For example, a <code>data-abc-def</code> attribute corresponds to <code>dataset.abcDef</code>.</p>

<h3 id="Accessing_values">Accessing values</h3>

<ul>
 <li>Attributes can be set and read by the camelCase name/key as an object property of the dataset: <code><var>element</var>.dataset.<var>keyname</var></code></li>
 <li>Attributes can also be set and read using bracket syntax: <code><var>element</var>.dataset['<var>keyname</var>']</code></li>
 <li>The <a href="/en-US/docs/Web/JavaScript/Reference/Operators/in"><code>in</code> operator</a> can check if a given attribute exists: <code>'keyname' in element.dataset</code></li>
</ul>

<h3 id="Setting_values">Setting values</h3>

<ul>
 <li>When the attribute is set, its value is always converted to a string.
  <div class="notecard note">
  <p><strong>For example:</strong> <code>element.dataset.example = null</code> is converted into <code>data-example="null"</code>.</p>
  </div>
 </li>
 <li>To remove an attribute, you can use the <a href="/en-US/docs/Web/JavaScript/Reference/Operators/delete"><code>delete</code> operator</a>: <code>delete element.dataset.<em>keyname</em></code></li>
</ul>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">const <var>dataAttrMap</var> = <var>element</var>.dataset
</pre>

<h3 id="Value">Value</h3>

<p>A {{domxref("DOMStringMap")}}.</p>

<h2 id="Examples">Examples</h2>

<pre class="brush: html notranslate">&lt;div id="user" data-id="1234567890" data-user="johndoe" data-date-of-birth&gt;John Doe&lt;/div&gt;</pre>

<pre class="brush: js notranslate">const el = document.querySelector('#user');

// el.id === 'user'
// el.dataset.id === '1234567890'
// el.dataset.user === 'johndoe'
// el.dataset.dateOfBirth === ''

// set a data attribute
el.dataset.dateOfBirth = '1960-10-03';
// Result: el.dataset.dateOfBirth === '1960-10-03'

delete el.dataset.dateOfBirth;
// Result: el.dataset.dateOfBirth === undefined

if ('someDataAttr' in el.dataset === false) {
  el.dataset.someDataAttr = 'mydata';
  // Result: 'someDataAttr' in el.dataset === true
}
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('HTML WHATWG', "dom.html#dom-dataset", "HTMLElement.dataset")}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td>No change from latest snapshot, {{SpecName('HTML5.1')}}</td>
  </tr>
  <tr>
   <td>{{SpecName('HTML5.1', "dom.html#dom-dataset", "HTMLElement.dataset")}}</td>
   <td>{{Spec2('HTML5.1')}}</td>
   <td>Snapshot of {{SpecName('HTML WHATWG')}}, no change from {{SpecName('HTML5 W3C')}}</td>
  </tr>
  <tr>
   <td>{{SpecName('HTML5 W3C', "dom.html#dom-dataset", "HTMLElement.dataset")}}</td>
   <td>{{Spec2('HTML5 W3C')}}</td>
   <td>Snapshot of {{SpecName('HTML WHATWG')}}, initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.HTMLElement.dataset")}}</p>

<div class="hidden">Please change the compat macro's paramter to <code>api.HTMLOrForeignElement.dataset</code> after BCD is updated.</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>The HTML <a href="/en-US/docs/Web/HTML/Global_attributes/data-*"><code>data-*</code></a> class of global attributes.</li>
 <li><a href="/en-US/docs/Learn/HTML/Howto/Use_data_attributes">Using data attributes</a></li>
 <li>{{DOMxRef("Element.getAttribute()")}} and {{DOMxRef("Element.setAttribute()")}}</li>
</ul>
